{*------------------------------------------*}
{*            S C A N  &  D E L             *}
{*------------------------------------------*}

Program Scad;

Uses CRT,DOS;

Var
   DelSize  : Longint;
   dir,
   currdir  : PathStr;
   namefull : String[55];
   Mask     : String;
   MName    : NameStr;
   Ext      : ExtStr;
   Path     : DirStr;
   Param    : String;
   PointM   : byte;
   Fcount,
   Count    : Integer;
   Iores    : Integer;
   i        : word;
   Ch1      : Char;
   DelTree,
   ConfDel,
   AllF,
   Wipe    : Boolean;

{-----------------------------------------------}
Function Upper(Ch:Char):Char;
{ Convert Char to UPPER case }

var

  OutCH: Char;

begin
  OutCh:=Ch;
  if (Ch>='a') and (Ch<='z') then OutCh:=Chr(Ord(Ch) - $20)
  else if (Ch>='' {rus}) and (Ch<='') then OutCh:=Chr(Ord(Ch) - $20)
   else if (Ch>='' {rus}) and (Ch<='') then OutCh:=Chr(Ord(Ch) - $50)
    else if (Ch='') then Ch:='';

 Upper:=OutCh;
end; { Upper }

{--------------  ---------------------------}
Function StUpCase(S:String):String;
var
  i : Integer;
begin
  for i := 1 to Length(s) do
    s[i] := Upper(s[i]);
  StUpCase:=S;
end;

{-------------------------------------------------}
Function Rtrim(Strin:String):String;
Var
   Slen: Byte Absolute Strin;
   i,j:Byte;
Begin
   j:=Slen;
   For i:=Slen downto 1 do begin
      If Strin[i]=' ' then j:=i-1
                      else i:=1;
   end;
   Rtrim:=Copy(Strin,1,j);
end; { }


{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}

Function Expand(S: String;Len:integer): string;
  { Expand source string up to LEN length}
var
     l,i : byte;
      s1 : string;
    Stop : boolean;
begin
    Stop:=False;
    s1:=s;
    l:=Length(s);
    i:=l+1;
    S1[0]:=chr(Len);
    If l<Len then begin
       while i<=Len do begin
          S1[i]:=' ';
          i:=i+1;
       end;
    end;
    Expand:=s1;
end;


{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}
Procedure WriteDosErr(DosErr:Integer);
Var Msg:String[40];
Begin
   {  A value of 0 indicates no error;
   other possible error codes include:}
   Case DosErr of
   0 : Msg:='';
   2 : Msg:='*** File not found ***';
   3 : Msg:='*** Path not found ***';
   5 : Msg:='*** Access denied ***';
   6 : Msg:='*** Invalid handle ***';
   8 : Msg:='*** Not enough memory ***';
  10 : Msg:='*** Invalid environment ***';
  11 : Msg:='*** Invalid format ***';
  18 : Msg:='*** No files ***';
 100 : Msg:='*** Read error ***';
 101 : Msg:='*** Write error ***';
  50 : Msg:='*** Not copying to current path ***';
  else Msg:='*** Unrecognized error ***';
 end; {Case}
 Writeln(Msg);
end;

{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}
Procedure WriteHeader;
Begin
   Writeln;
   Writeln('<<<  SCAD - Scan and Delete files >>>');
   Writeln('<<<    (C) 1989 by V.Votintsev    >>>');
   Writeln('<<<        Info-Link,ltd.         >>>');
   Writeln('<<<E-Mail: vot@infolink.tver.su   >>>');
   Writeln;
end;

{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}
Procedure WriteHelp;
Begin
   WriteHeader;
   Writeln('Usage: SCAD mask [/S/W/Y/H]');
   Writeln('where  mask - start directory and mask for deleting');
   Writeln('              ( f.e. "c:\dos\*.bak" )');
   Writeln('       [/Y] - quiet for delete;');
   Writeln('       [/S] - delete files in subdirectories below;');
   Writeln('       [/W] - wipe files before deleting;');
   Writeln('       [/H] - display this HELP.');
   Writeln('More detail information see in the SCADread.me');
end;
{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}
Function CompStr(Mas,Fil:string):boolean;
Var
   i,j : integer;
   Ok:Boolean;
   LenFil:Byte absolute Fil;
   LenMas:Byte absolute Mas;
   MaxLen:Byte;
Begin
   j:=1;
   If AllF then Ok:=True
   else begin
      MaxLen:=LenFil;
      If LenMas>LenFil then begin
         MaxLen:=LenMas;
         Fil:=Expand(Fil,MaxLen);
      end;
      Ok:=False;
      For i:=1 to LenMas do begin
         If Mas[i]='*' then begin
            Ok:=True;
            i:=LenMas;
         end else begin
            If Mas[i]='?' then begin
               Ok:=True;
               Inc(j);
            end else begin
               If Mas[i]=Fil[j] then begin
                  Ok:=True;
                  inc(j);
               end else begin
                  Ok:=False;
                  i:=LenMas;
               end;
            end;
         end;
      end;
   end;
   CompStr:=Ok;
end;


{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}
Function GetPath(Str:string):string;

Var
   i,k:byte;
   l: byte absolute Str;
   currpath:pathstr;

begin
   currPath:=Str;
   k:=0;
   For i:= l downto 1 do begin
      If (Str[i]= '\') {or (Str[i]=':')} then begin
         k:=i;
         i:=1;
      end;
   end;
   currpath[0]:=chr(k);

   GetPath:=CurrPath;
end;

{*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*}
Procedure Scandir(dir:string);

Var
  FInfo   : searchrec;
  NewName : NameStr;
  NewExt  : ExtStr;
  NewSize : Longint;
  Dirc    : string;
  Dir1    : String;
  lpath   : DirStr;

Procedure ERaseFile;
var
    F : File;
    Buf : Array [1..512] of byte;
    BlockNum : Longint;
    NumRead, NumWritten: Word;
    Fsize : longint;
    ch: char;
begin
   namefull:=currdir + NewName + NewExt;
   NewSize := FInfo.size;
   Write('Delete '); Write(currdir + NewName);
   Write(NewExt,' ',NewSize);
   If ConfDel then begin
      Write(' (YNAQ) ? ');
      repeat
         ch := ReadKey;
         ch := UpCase(ch);
      until (ch = 'Y') or (ch = 'N') or (ch = 'A') or (ch = 'Q');
      Write(ch);
   end
   else ch:='Y';
   Writeln;
   If ch='A' then ConfDel:=False;

   If ch='Q' then DosError:=111
   else begin

      If (ch = 'Y') or (ch = 'A') then Begin
         Assign(F,namefull);
         Iores:=Ioresult;
         If Iores<>0 then begin
            DosError:=3;
            {$i-}
            Close(F);
            {$i+}
            WriteDosErr(DosError);
            Halt(1);
         end
         else begin
            If Wipe then begin
               Reset(F,1);
               Fsize:=FileSize(F);
               BlockNum:=0;
               repeat
                  Seek(F,BlockNum*512);
                  BlockRead(F,buf,512,NumRead);
                  for i:=1 to 512 do buf[i]:=0;
                  Seek(F,BlockNum*512);
                  BlockWrite(F,Buf,NumRead,NumWritten);
                  Inc(BlockNum);
               until (NumRead = 0) or (NumWritten <> NumRead);
               Close(F);
            end; {If Wipe}
            Erase(F);
            Inc(FCount);
            DelSize := DelSize + NewSize;
         end;
      end;
   end;
end;

{**** SCANDIR ****}
Begin
  currdir := currdir + Dir ;
  If Currdir[Length(Currdir)]<>'\' then currdir:=currdir+'\';

  FindFirst(currdir + '*.*' + chr(0),anyfile,FInfo);

  repeat
     NewName:='';
     Fsplit(FInfo.name,lpath,newname,newext);
     If NewExt='' then NewExt:='.';
     If ((FInfo.attr and $10) = $10) and (FInfo.name[1]<>'.')
     and (copy(FInfo.name,1,2)<>'..')  then begin

        If DelTree then scandir(FInfo.Name)
     else currdir:=currdir + FInfo.name+'\';
     currdir := copy(currdir,1,length(currdir)-1);
     Dirc:=currdir;

     CurrDir:=GetPath(Dirc);
     end

     else  begin
        If (((FInfo.attr and $10) <> $10) and (FInfo.name[1]<>'.')
        and (copy(FInfo.name,1,2)<>'..') ) then begin
           If (CompStr(Ext,NewExt)) and (CompStr(Mname,NewName)) then
              EraseFile;
        end;
     end;
     If DosError<>111 then begin
        FindNext(FInfo);
        i:=i;
     end;
  until (DosError <> 0);
  if (DosError<>18) and (DosError<>111) then
     WriteDosErr(DosError);
End;

{*-*-*-*-P-R-O-G-R-A-M-*-B-O-D-Y-*-*-*-*-*-*-*}

BEGIN

   writeHeader;

   If ParamCount < 1 then WriteHelp
   else BEGIN

      AllF := False;
      DelTree := False;
      Wipe:=False;
      ConfDel:=False;
      Mask :=StUpCase(ParamStr(1));

      Fcount := 0;
      DelSize:=0;
      CurrDir:='';
      If Mask='/H' then begin
         WriteHelp;
         Halt;
      end;
      Mask :=Fexpand(Mask);
      Param:='';

      for count:=2 to Paramcount do
         Param:=Param+StUpcase(Rtrim(ParamStr(count)));

      For i:=1 to length(param) do begin
         Ch1:=param[i];
         case Ch1 of
           '/': begin end;
           'Y': ConfDel := True;
           'S': DelTree := True;
           'W': Wipe    := True;
           'H': WriteHelp;
           else begin
             Writeln('Invalid Parameter: /',Ch1);
             WriteHelp;
             Halt;
           end;
        end;   { of case }
     end;

     fsplit(Mask,Path,Mname,Ext);
     If (Mname = '*') and (Ext='.*') then AllF:=True;
     getdir(0,dir);
     currdir := '';

     scandir(Path);

     chdir(dir);
     Write('Files deleted: ',FCount,'.  ');
     Writeln('Total size: ',DelSize,' bytes.');
   END;
END.

